Last Comment Bug 818560 - build.sh changes to accomodate gecko multilocale
: build.sh changes to accomodate gecko multilocale
Status: RESOLVED FIXED
:
Product: Firefox OS
Classification: Client Software
Component: GonkIntegration (show other bugs)
: unspecified
: All All
: P1 normal (vote)
: B2G C2 (20nov-10dec)
Assigned To: Michael Wu [:mwu]
:
:
Mentors:
Depends on: 796051
Blocks: 812831 812833 812835 812836
  Show dependency treegraph
 
Reported: 2012-12-05 10:05 PST by Aki Sasaki [:aki]
Modified: 2014-10-09 21:40 PDT (History)
9 users (show)
See Also:
Crash Signature:
(edit)
QA Whiteboard:
Iteration: ---
Points: ---
+


Attachments

Description Aki Sasaki [:aki] 2012-12-05 10:05:13 PST
We don't seem to have a way to run individual make commands mid-build, so afaict we need to add multilocale build+package steps to build.sh.

This will most likely be conditional on environment variables, so the default developer build stays as-is.

This blocks multiple blocking-basecamp+ C2 bugs, so marking as such.
Comment 1 Aki Sasaki [:aki] 2012-12-05 10:45:33 PST
I think we will need bug 817197 to package appropriately.
Comment 2 Andrew Overholt [:overholt] 2012-12-05 10:48:33 PST
Ben, is this something you can do?  If not, any suggestions as to who should own this?
Comment 3 Ben Hearsum (:bhearsum) 2012-12-05 10:52:57 PST
I know absolutely nothing about the B2G build system, sorry :(. Maybe Fabrice or one of the other original authors of it?
Comment 4 [:fabrice] Fabrice Desré 2012-12-05 10:55:52 PST
Michael, can you help there?
Comment 5 Damon Sicore (:damons) 2012-12-06 08:34:09 PST
This needs an owner who can actually resolve... asap.  Reaching out to Bob Moss to make sure it happens.
Comment 6 Michael Wu [:mwu] 2012-12-06 08:41:57 PST
I got this.
Comment 7 Michael Wu [:mwu] 2012-12-06 20:22:16 PST
I'll try to get this all fixed up on Friday (7th). This mostly depends on bug 817197 to do most of the work and then I'll add some bits to gonk-misc to make it all stick together. We'll need to figure out how to make the l10n stuff work for our friends though - maybe add git mirrors for the l10n stuff and get this into the manifest.
Comment 8 Axel Hecht [:Pike] 2012-12-07 02:32:16 PST
For developers, we're keeping the few locales in gaia's git, and they should be fine, even if the network errors are not translated.

For downstream parties, they'll work off of hg, as does our automation infrastructure.

As for git mirrors for l10n, there are many reasons against doing those, don't want to clutter this bug with that discussion. I don't see a need for them here, though, too.
Comment 9 Michael Wu [:mwu] 2012-12-07 15:41:16 PST
The appropriate pieces have landed in gonk-misc and B2G.

All you have to do is set MOZ_CHROME_MULTILOCALE and L10NBASEDIR in the environment and the B2G build system will take care of the rest. These two can be set in the .userconfig. For example I have this in my userconfig:

L10NBASEDIR=$PWD/l10n-base
MOZ_CHROME_MULTILOCALE="ja zh-TW"
Comment 10 Axel Hecht [:Pike] 2012-12-07 15:50:16 PST
That'd be https://github.com/mozilla-b2g/gonk-misc/commit/e63bbf6c3f5a116b7b605e4d2bd93c84bd4b99ad and https://github.com/mozilla-b2g/B2G/commit/41c17a6abfd5f488ec99d9aa246f5b07583403c7, right?

Does that trigger what we need to trigger for the gaia side?
Comment 11 Axel Hecht [:Pike] 2012-12-07 15:53:12 PST
The patches I found are not related to gecko repos, so unblocking the uplift bug 818907.
Comment 12 Michael Wu [:mwu] 2012-12-07 15:54:00 PST
(In reply to Axel Hecht [:Pike] from comment #10)
> Does that trigger what we need to trigger for the gaia side?

I haven't touched the gaia side at all. As far as I can tell, gaia already installs its set of locales without any intervention. I was enjoying the gaia lockscreen in zh-TW.
Comment 13 Michael Wu [:mwu] 2012-12-07 15:55:23 PST
(In reply to Axel Hecht [:Pike] from comment #11)
> The patches I found are not related to gecko repos, so unblocking the uplift
> bug 818907.

Note that releng will need to get their gonk toolchain/codedrop updated to start supporting this.
Comment 14 Ben Hearsum (:bhearsum) 2012-12-07 16:16:13 PST
(In reply to Michael Wu [:mwu] from comment #12)
> (In reply to Axel Hecht [:Pike] from comment #10)
> > Does that trigger what we need to trigger for the gaia side?
> 
> I haven't touched the gaia side at all. As far as I can tell, gaia already
> installs its set of locales without any intervention. I was enjoying the
> gaia lockscreen in zh-TW.

Yeah - the Gaia build system looks at LOCALE_BASEDIR and LOCALES_FILE. We enabled that in the RelEng builds a couple of days ago. Probably need to rename some of these vars at some point to avoid confusion, but it sounds like we're OK for now since they don't overlap.
Comment 15 Ben Hearsum (:bhearsum) 2012-12-10 08:39:01 PST
(In reply to Michael Wu [:mwu] from comment #13)
> (In reply to Axel Hecht [:Pike] from comment #11)
> > The patches I found are not related to gecko repos, so unblocking the uplift
> > bug 818907.
> 
> Note that releng will need to get their gonk toolchain/codedrop updated to
> start supporting this.

Filed bug 819979 for this.
Comment 16 Ben Hearsum (:bhearsum) 2012-12-12 07:56:25 PST
I'm having a bit of trouble with this. I have L10NBASEDIR and MOZ_CHROME_MULTILOCALE set in the environment, but I get the following error when building:
07:42:05     INFO -  make -C gecko -f client.mk -s
07:42:06     INFO -  Adding client.mk options from /builds/slave/b2g-m-cen-otoro-dep/build/gonk-misc/default-gecko-config:
07:42:06     INFO -      MOZ_OBJDIR=/builds/slave/b2g-m-cen-otoro-dep/build/objdir-gecko
07:42:06     INFO -      MOZ_MAKE_FLAGS=-s -j16
07:42:06     INFO -  TEST-PASS | check-sync-dirs.py | /builds/slave/b2g-m-cen-otoro-dep/build/gecko/js/src/config <= /builds/slave/b2g-m-cen-otoro-dep/build/gecko/config
07:42:06     INFO -  make[3]: warning: -jN forced in submake: disabling jobserver mode.
07:42:06    ERROR -  /builds/slave/b2g-m-cen-otoro-dep/build/gecko/config/config.mk:693: *** L10NBASEDIR not defined by configure.  Stop.
07:42:06     INFO -  make[3]: INTERNAL: Exiting with 17 jobserver tokens available; should be 16!
07:42:06    ERROR -  make[2]: *** [realbuild] Error 2
07:42:06    ERROR -  make[1]: *** [build] Error 2

I'm trying to debug, but any pointers or suggestions would be appreciated.
Comment 17 Michael Wu [:mwu] 2012-12-12 08:02:39 PST
A clobber build is necessary to pick up L10NBASEDIR.
Comment 18 Ben Hearsum (:bhearsum) 2012-12-12 08:15:51 PST
(In reply to Michael Wu [:mwu] from comment #17)
> A clobber build is necessary to pick up L10NBASEDIR.

That got me past the error - thanks.

Note You need to log in before you can comment on or make changes to this bug.